/***********************************************************************
* Copyright (c) 2011 Samu Juvonen <samu.juvonen@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
************************************************************************/

#ifndef BOOKMARKMODEL_H
#define BOOKMARKMODEL_H

#include <QStandardItemModel>

class BookmarkModel : public QStandardItemModel {
	Q_OBJECT

	public:
		enum Roles { FilePathRole = Qt::UserRole+1, DisplayNameRole=Qt::UserRole+2 };
		
		BookmarkModel(QObject * parent=0);

		bool setName(const QString & name, const QString & path);
		bool setName(const QString & name, int row);

		QModelIndex indexForPath(const QString & path) const;
		
		QVariant data(const QModelIndex &, int role=Qt::DisplayRole) const;

		bool setData(const QModelIndex &, const QVariant &, int role = Qt::EditRole);

	public slots:
		bool addPath(const QString & path, const QString & name=QString());
		bool removePath(const QString &);

	private slots:
		void saveBookmarks();

	private:
		void loadBookmarks();
};

#endif